package com.zd.exam.mapper;

import com.zd.exam.domain.ElQu;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 问题题目(ElQu)表数据库访问层
 *
 * @author liubo
 * @since 2021-08-30 15:26:29
 */
public interface ElQuMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ElQu queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<ElQu> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param elQu 实例对象
     * @return 对象列表
     */
    List<ElQu> queryAll(ElQu elQu);

    /**
     * 新增数据
     *
     * @param elQu 实例对象
     * @return 影响行数
     */
    int insert(ElQu elQu);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElQu> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ElQu> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElQu> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<ElQu> entities);

    /**
     * 修改数据
     *
     * @param elQu 实例对象
     * @return 影响行数
     */
    int update(ElQu elQu);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    int deleteByIds(List<Long> ids);

    List<ElQu> listByRandom(
                            @Param("repoId") Long repoId,
                            @Param("quType") Integer quType,
                            @Param("level") Integer level,
                            @Param("excludes") List<Long> excludes,
                            @Param("size") Integer size);

    List<ElQu> otherListByRandom(@Param("repoId") Long repoId,
                                 @Param("quType") Integer quType,
                                 @Param("level") Integer level,
                                 @Param("excludes") List<Long> excludes,
                                 @Param("size") Integer size);

    List<ElQu> queryByIds(@Param("quIds") List<Long> quIds, @Param("cIds") List<Long> cIds, @Param("quNum") Integer quNum);

    List<ElQu> listByRandomClassifyId(@Param("classifyId") Long classifyId,
                                      @Param("quType") Integer quType,
                                      @Param("level") Integer level,
                                      @Param("excludes") List<Long> excludes,
                                      @Param("size") Integer size);

    Map<String, Integer> selectQuCountByClassifyIds(@Param("classifyIds") List<Long> classifyIds);
}

